"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventListeners = void 0;
var safeGet_1 = __importDefault(require("licia/safeGet"));
var isEl_1 = __importDefault(require("licia/isEl"));
var isFn_1 = __importDefault(require("licia/isFn"));
var isBool_1 = __importDefault(require("licia/isBool"));
var keys_1 = __importDefault(require("licia/keys"));
var each_1 = __importDefault(require("licia/each"));
var defaults_1 = __importDefault(require("licia/defaults"));
var isObj_1 = __importDefault(require("licia/isObj"));
var objManager = __importStar(require("../lib/objManager"));
function getEventListeners(params) {
    var obj = objManager.getObj(params.objectId);
    var events = obj.chobitsuEvents || [];
    var listeners = [];
    each_1.default(events, function (events, type) {
        each_1.default(events, function (event) {
            listeners.push({
                type: type,
                useCapture: event.useCapture,
                handler: objManager.wrap(event.listener),
                passive: event.passive,
                once: event.once,
                scriptId: '1',
                columnNumber: 0,
                lineNumber: 0,
            });
        });
    });
    return {
        listeners: listeners,
    };
}
exports.getEventListeners = getEventListeners;
var getWinEventProto = function () {
    return safeGet_1.default(window, 'EventTarget.prototype') || window.Node.prototype;
};
var winEventProto = getWinEventProto();
var origAddEvent = winEventProto.addEventListener;
var origRmEvent = winEventProto.removeEventListener;
winEventProto.addEventListener = function (type, listener, options) {
    addEvent(this, type, listener, options);
    origAddEvent.apply(this, arguments);
};
winEventProto.removeEventListener = function (type, listener) {
    rmEvent(this, type, listener);
    origRmEvent.apply(this, arguments);
};
function addEvent(el, type, listener, options) {
    if (options === void 0) { options = false; }
    if (!isEl_1.default(el) || !isFn_1.default(listener))
        return;
    if (isBool_1.default(options)) {
        options = {
            capture: options,
        };
    }
    else if (!isObj_1.default(options)) {
        options = {};
    }
    defaults_1.default(options, {
        capture: false,
        passive: false,
        once: false,
    });
    var events = (el.chobitsuEvents = el.chobitsuEvents || {});
    events[type] = events[type] || [];
    events[type].push({
        listener: listener,
        useCapture: options.capture,
        passive: options.passive,
        once: options.once,
    });
}
function rmEvent(el, type, listener) {
    if (!isEl_1.default(el) || !isFn_1.default(listener))
        return;
    var events = el.chobitsuEvents;
    if (!(events && events[type]))
        return;
    var listeners = events[type];
    for (var i = 0, len = listeners.length; i < len; i++) {
        if (listeners[i].listener === listener) {
            listeners.splice(i, 1);
            break;
        }
    }
    if (listeners.length === 0)
        delete events[type];
    if (keys_1.default(events).length === 0)
        delete el.chobitsuEvents;
}
