"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isImage = exports.getImages = exports.getScripts = void 0;
var map_1 = __importDefault(require("licia/map"));
var filter_1 = __importDefault(require("licia/filter"));
var compact_1 = __importDefault(require("licia/compact"));
var contain_1 = __importDefault(require("licia/contain"));
var isPerformanceSupported = false;
var performance = window.webkitPerformance || window.performance;
if (performance && performance.getEntries) {
    isPerformanceSupported = true;
}
function getScripts() {
    if (isPerformanceSupported) {
        return getResources('script');
    }
    var elements = document.querySelectorAll('script');
    return compact_1.default(map_1.default(elements, function (element) { return element.src; }));
}
exports.getScripts = getScripts;
function getImages() {
    if (isPerformanceSupported) {
        return getResources('img');
    }
    var elements = document.querySelectorAll('img');
    return compact_1.default(map_1.default(elements, function (element) { return element.src; }));
}
exports.getImages = getImages;
function isImage(url) {
    return contain_1.default(getImages(), url);
}
exports.isImage = isImage;
function getResources(type) {
    return map_1.default(filter_1.default(performance.getEntries(), function (entry) { return entry.initiatorType === type; }), function (entry) { return entry.name; });
}
